
#define DEFAULTBLOCKSIZE 172
typedef struct _smemberinfo
{
	int number;
	char name[20];
	char tel[20];
	char address[80];
	char comment[40];
	_smemberinfo *prev;
	_smemberinfo *next;
}MemberInfo;
//main function global(extern)
MemberInfo *pmemberinfo;

void init()
{
	pmemberinfo = (MemberInfo *)malloc(DEFAULTBLOCKSIZE);
	pmemberinfo->prev=0;
	pmemberinfo->next=0;
	pmemberinfo->number=0;
	strcpy(pmemberinfo->name,"root");
	strcpy(pmemberinfo->tel,"");
	strcpy(pmemberinfo->address,"");
	strcpy(pmemberinfo->comment,"");
}

void addnew(char *name,char *tel,char *address,char *comment)
{
	MemberInfo *p,*np;
	p=pmemberinfo;
	while(p->next)
		p=p->next;
	np= (MemberInfo *)malloc(DEFAULTBLOCKSIZE);
	p->next=np;
	np->prev=p;
	np->next=0;
	strcpy(np->name,name);
	strcpy(np->tel,tel);
	strcpy(np->address,address);
	strcpy(np->comment,comment);
}
void deletedata(MemberInfo *delp)
{
	MemberInfo *prev,*next;
	prev=delp->prev;
	next=delp->next;
	prev->next=next;
	next->prev=prev;
	free(delp);
}
MemberInfo *finddata(char *seek,int mode)
{
	MemberInfo *p;
	p=pmemberinfo->next;
	int seek;
	seek=0;
	while(p)
	{
		switch(mode)
		{
			case 0:
					if(strstr(p->name,seek))seek=1;
					break;
			case 1:
					if(strstr(p->tel,seek))seek=1;
					break;
		}
		if(seek)
		break;
		p=p->next;
	}
	return p;
}
void loaddata(char *filename)
{
	int fd,total,i,num;
	char temp[DEFAULTBLOCKSIZE-12];
	char name[20],tel[20],address[80],comment[40];
	fd=open(filename,O_RDWR)
	read(fd,(char *)total,sizeof(total));
	for(i=0;i<total;i++)
	{
		read(fd,(char *)num,sizeof(num));
		read(fd,temp,DEFAULTBLOCKSIZE-12);
		memcpy(name,temp,20);
		memcpy(tel,temp+20,20);
		memcpy(address,temp+40,80);
		memcpy(comment,temp+120,40);
		addnew(name,tel,address,comment);
	}
	close(fd);
}
void savedata(char *filename)
{
	int fd,total;
	MemberInfo *p;
	p=pmemberinfo->next;
	total=0;
	while(p)
	{
		p=p->next;
		total++;
	}
	p=pmemberinfo->next;
	fd=creat(filename,0666);
	write(fd,(char *)total,sizeof(total));
	for(i=0;i<total;i++)
	{
		write(fd,p->number,sizeof(p->number));
		write(fd,p->name,20);
		write(fd,p->tel,20);
		write(fd,p->address,80);
		write(fd,p->comment,40);
	}
	close(fd);
	
}


int total,fd;
fd=creat("test.db",0666);
total=0;
write(fd,(char *)fd,sizeof(fd));
fclose(fd);








