#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <semaphore.h>

void *thread_function(void *arg);
sem_t bin_sem;

#define WORK_SIZE 1024
char work_area[WORK_SIZE];

int main()
{
	int res;
	pthread_t a_thread;
	void *thread_result;

	res=sem_init(&bin_sem,0,0);
	
	res=pthread_create(&a_thread,NULL,thread_function,NULL);

	printf("Input some text.Enter 'end' to finish\n");
	while(strncmp("end",work_area,3) !=0 )
	{
		fgets(work_area,WORK_SIZE,stdin);
		sem_post(&bin_sem);
	}
	printf("\naiting for thread to finish...\n");
	res=pthread_join(a_thread,&thread_result);
	printf("Thread joined\n");
	exit(1);
}
void *thread_function(void *arg)
{
	sem_wait(&bin_sem);
	while(strncmp("end",work_area,3) !=0)
	{
		printf("You input %d characters\n",strlen(work_area)-1);
		sem_wait(&bin_sem);
	}
	pthread_exit(0);
}
