#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>

int main(void)
{
	//----- variables -----//
	struct sockaddr_in address;
	int sock, conn, i, curr;
	int childpid;
	size_t addrLength = sizeof(struct sockaddr_in);
	char buff[512];

	//----- socket operations -----//
	// create listen socket //
	if((sock = socket(PF_INET, SOCK_STREAM, 0)) < 0)
	{
		printf("[Err] socket creation error\n");
		return 1;
	}

	// set socket option //
	i=1;
	setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &i, sizeof(i));

	// set address information //
	address.sin_family = AF_INET;
	address.sin_port = htons(2714);
	memset(&address.sin_addr, 0, sizeof(address.sin_addr));

	// bind address //
	if(bind(sock, (struct sockaddr *)&address, sizeof(address)))
	{
		printf("[Err] bind address error\n");
		return 1;
	}

	// listen //
	if(listen(sock, 5))
	{
		printf("[Err] listen error\n");
		return 1;
	}

	// accept socket //
	conn = accept(sock, (struct sockaddr *)&address, &addrLength);

	{
			// notify //
			printf("[Log] new connection\n");

			//----- set current socket -----//
			curr = conn;

			//----- receive data from socket -----//
			while(1)
			{
				// receive request from client //
				recv(curr, buff, 512, 0);
				printf("receive data %s\n",buff);
				gets(buff);
				printf("send data:%s\n",buff);
				send(curr, buff, 512, 0);
				if(strstr(buff,"end"))
					break;
			}
	}

	// close listeing socket //
	close(sock);
	return 0;
}
